(function() {
    "use strict";

    var script = document.querySelector("#pirschjs");
    var endpoint = script.getAttribute("data-endpoint") || "https://api.pirsch.io/hit";
    var trackingCode = script.getAttribute("data-code");

    if(/^localhost(.*)$|^127(\.[0-9]{1,3}){3}$/is.test(location.hostname) || location.protocol === "file:") {
        console.warn("You're running Pirsch on localhost. Hits will be ignored.");
        return;
    }

    function hit() {
        var nocache = new Date().getTime();
        var location = location;
        var referrer = document.referrer;
        var width = screen.width;
        var height = screen.height;
        var url = endpoint+
            "?nocache="+ nocache+
            "&code="+trackingCode+
            "&location="+location+
            "&referrer="+referrer+
            "&width="+width+
            "&height="+height;

        var req = new XMLHttpRequest();
        req.open("GET", url);
        req.send();
    }

    if(history.pushState) {
        var pushState = history["pushState"];

        history.pushState = function() {
            pushState.apply(this, arguments);
            hit();
        }

        window.addEventListener("popstate", hit);
    }

    if(!document.body) {
        window.addEventListener("DOMContentLoaded", hit);
    } else {
        hit();
    }
})();
